/* $B3d$j9~$_%Y%/%?(B */

	.section .vector,"ax"
	.thumb
	.align 0

	.long	_main_stack		// MSP default value
	.long	reset_entry + 1		//  1: Reset
	.long	die + 1			//  2: NMI
	.long	die + 1			//  3: HardFault
	.long	die + 1			//  4: reserved
	.long	die + 1			//  5: reserved
	.long	die + 1			//  6: reserved
	.long	die + 1			//  7: reserved
	.long	die + 1			//  8: reserved
	.long	die + 1			//  9: reserved
	.long	die + 1			// 10: reserved
	.long	die + 1			// 11: SVCall
	.long	die + 1			// 12: reserved
	.long	die + 1			// 13: reserved
	.long	die + 1			// 14: PendSV
	.long	die + 1			// 15: SysTick

/* $B%9%?!<%H%"%C%W(B */

	.section .text
	.thumb
	.align 0
	.global reset_entry

reset_entry:
	/* $B%\!<%I8GM-$N@_Dj(B */
	bl	board_setup

	/* .data$B$N=i4|2=(B */
data_init:
	ldr	r1, =_data_org
	ldr	r2, =_data_start
	ldr	r3, =_data_end
	cmp	r2, r3
	beq	bss_init
data_loop:
	ldr	r0, [r1]
	add	r1, r1, #4
	str	r0, [r2]
	add	r2, r2, #4
	cmp	r2, r3
	bne	data_loop

	/* .bss$B$N=i4|2=(B */
bss_init:
	mov	r0, #0
	ldr	r2, =_bss_start
	ldr	r3, =_bss_end
	cmp	r2, r3
	beq	start_main
bss_loop:
	str	r0, [r2]
	add	r2, r2, #4
	cmp	r2, r3
	bne	bss_loop

	/* $B%a%$%s(B */
start_main:
	mov	r0, #0
	bl	main
	b	die

	.globl execute
execute:
	ldmia	r0, {r0, r1}
	mov	sp, r0
	bx	r1

	/* $BK=AvKI;_MQ$NL58B%k!<%W(B */
die:
	b	die

	.pool
